// JavaScript Document

function IScrollHandler( options, wrapper )
{
	if( null == wrapper )
		wrapper = "#wrapper";
	
	/** 上拉加载更多、下拉刷新 **/
	var onRefreshHandler = options.onRefreshHandler, onNextHandler = options.onNextHandler;
	
	
	/** 滚动实例，文字显示区域高度 **/
	var myScroll, scrollOffset, momo = false;
	
	
	/** 处理文字显示 **/
	var downRefresh = false, upMore = false;
	var resetUpMore = function() 
	{
		if( null == onNextHandler ) return;
		upMore = false;
		if( $( wrapper ).find( "#bottomArea" )  ) 
			$( wrapper ).find( "#bottomArea" ).html( "上拉加载更多" );
	};
	var resetDownRefresh = function() 
	{
		if( null == onRefreshHandler ) return;
		downRefresh = false;
		if( $( wrapper ).find( "#topArea" )  )
			 $( wrapper ).find( "#topArea" ).html( "下拉刷新" );
	};
	var setShowRefresh = function()
	{
		if( null == onRefreshHandler ) return;
		downRefresh = true;
		if( $( wrapper ).find( "#topArea" )  )
			$( wrapper ).find( "#topArea" ).html( "松开刷新列表" );
	};
	var setShowMore = function()
	{
		if( null == onNextHandler ) return;
		upMore = true;
		if( $( wrapper ).find( "#bottomArea" )  ) 
			$( wrapper ).find( "#bottomArea" ).html( "松开加载更多" );
	};
	
	
	/** 重置列表 **/
	this.resetIScroll = 
	function()
	{	
		momo = false;
		
		/** 防止内容高度小于#wrapper高度时，不滚动 **/
		resetScrollerHeight();
		//$( "#scroller" ).css( "padding-top", 10 );	
		//$( "#scroller" ).css( "padding-bottom", 10 );	
		
		if( myScroll )
		{
			myScroll.refresh();
			return;
		}
		
		/** 文字显示就绪 **/		
		if( onRefreshHandler && $( wrapper ).find( "#topArea" ) )
			$( wrapper ).find( "#topArea" ).html( "下拉刷新" );
		else if( $( wrapper ).find( "#topArea" ) )
			$( wrapper ).find( "#topArea" ).html( "" );
		
		if( onNextHandler && $( wrapper ).find( "#bottomArea" ) )
			$( wrapper ).find( "#bottomArea" ).html( "上拉加载更多" );
		else if( $( wrapper ).find( "#bottomArea" )  )
			$( wrapper ).find( "#bottomArea" ).html( "" );
		
		if( $( wrapper ).find( "#topArea" ) )
			scrollOffset = $( wrapper ).find( "#topArea" ).height() + 30;
		
		/** 建立列表 **/
		myScroll = new IScroll( wrapper, { probeType: 3, mouseWheel: true } );
			myScroll.on( "scroll", 
			function()
			{
				if( momo ) return;
				if( this.y > scrollOffset )
					setShowRefresh();
				else
					resetDownRefresh();
								
				if( this.y < -(  $( wrapper ).find( "#scroller" ).height() + scrollOffset - $( wrapper ).height() ) )
					setShowMore();
				else
					resetUpMore();
			} );
		
		
		
		myScroll.on( "scrollMomo", 
		function()
		{
			momo = true;	
		} );
		myScroll.on( "scrollEnd", 
		function()
		{
			momo = false;
			if( upMore == true ) 
			{
				resetUpMore();	
				if( onNextHandler ) onNextHandler();
			}
			if( downRefresh == true )
			{
				resetDownRefresh();
				if( onRefreshHandler ) onRefreshHandler();
			}
		} );

		document.addEventListener( 'touchmove', function (e) { e.preventDefault(); }, false );
		
		$( window ).bind( "resize", resetScrollerHeight );
	}
	
	
	
	function resetScrollerHeight( event )
	{
		$( wrapper ).find( "#scroller" ).css( "min-height", $( wrapper ).height() + 1 );
	}
	
	
	
					
	this.scrollToIndex = 
	function( index )
	{
		if( myScroll )
		{
			var el = $( wrapper ).find( "#scroller" ).children().get( index + 1 );
			if( el )
				myScroll.scrollToElement( el );
		}
	};
	
	
	
}